1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
84 my $ok = join("|", qw(
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
114 export GIT_TRACE_BARE
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
127 setup_malloc_check () {
130 teardown_malloc_check () {
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
143 : ${ASAN_OPTIONS=detect_leaks=0}
146 # Protect ourselves from common misconfiguration to export
147 # CDPATH into the environment
153 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
164 # A regexp to match 5 and 40 hexdigits
165 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
169 _z40=0000000000000000000000000000000000000000
175 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
176 # when case-folding filenames
177 u200c=$(printf '\342\200\214')
179 export _x05 _x40 _z40 LF u200c
181 # Each test should start with something like this, after copyright notices:
183 # test_description='Description of this test...
184 # This test checks if command xyzzy does the right thing...
187 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
188 TERM=$ORIGINAL_TERM &&
191 tput bold >/dev/null 2>&1 &&
192 tput setaf 1 >/dev/null 2>&1 &&
193 tput sgr0 >/dev/null 2>&1
197 while test "$#" -ne 0
200 -d|--d|--de|--deb|--debu|--debug)
202 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
203 immediate=t; shift ;;
204 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
205 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
207 shift; test "$#" -ne 0 || {
208 echo 'error: -r requires an argument' >&2;
211 run_list=$1; shift ;;
213 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
214 -h|--h|--he|--hel|--help)
216 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
219 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
221 -q|--q|--qu|--qui|--quie|--quiet)
222 # Ignore --quiet under a TAP::Harness. Saying how many tests
223 # passed without the ok/not ok details is always an error.
224 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
226 with_dashes=t; shift ;;
229 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
233 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
236 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
239 shift ;; # was handled already
241 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
248 echo "error: unknown test option '$1'" >&2; exit 1 ;;
252 if test -n "$valgrind_only"
254 test -z "$valgrind" && valgrind=memcheck
255 test -z "$verbose" && verbose_only="$valgrind_only"
256 elif test -n "$valgrind"
269 tput bold; tput setaf 1;; # bold red
271 tput setaf 4;; # blue
273 tput setaf 3;; # brown/yellow
275 tput setaf 2;; # green
277 tput setaf 6;; # cyan
279 test -n "$quiet" && return;;
289 test -z "$1" && test -n "$quiet" && return
296 say_color error "error: $*"
305 test "${test_description}" != "" ||
306 error "Test script did not set test_description."
308 if test "$help" = "t"
310 printf '%s\n' "$test_description"
316 if test "$verbose" = "t"
320 exec 4>/dev/null 3>/dev/null
329 test_external_has_tap=0
333 if test -n "$GIT_EXIT_OK"
337 echo >&5 "FATAL: Unexpected exit with code $code"
345 # The user-facing functions are loaded from a separate file so that
346 # test_perf subshells can have them too
347 . "$TEST_DIRECTORY/test-lib-functions.sh"
349 # You are not expected to call test_ok_ and test_failure_ directly, use
350 # the test_expect_* functions instead.
353 test_success=$(($test_success + 1))
354 say_color "" "ok $test_count - $@"
358 test_failure=$(($test_failure + 1))
359 say_color error "not ok $test_count - $1"
361 printf '%s\n' "$*" | sed -e 's/^/# /'
362 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
365 test_known_broken_ok_ () {
366 test_fixed=$(($test_fixed+1))
367 say_color error "ok $test_count - $@ # TODO known breakage vanished"
370 test_known_broken_failure_ () {
371 test_broken=$(($test_broken+1))
372 say_color warn "not ok $test_count - $@ # TODO known breakage"
376 test "$debug" = "" || eval "$1"
379 match_pattern_list () {
382 test -z "$*" && return 1
393 match_test_selector_list () {
398 test -z "$1" && return 0
400 # Both commas and whitespace are accepted as separators.
406 # If the first selector is negative we include by default.
414 orig_selector=$selector
420 selector=${selector##?}
424 test -z "$selector" && continue
428 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
430 echo "error: $title: invalid non-numeric in range" \
431 "start: '$orig_selector'" >&2
434 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
436 echo "error: $title: invalid non-numeric in range" \
437 "end: '$orig_selector'" >&2
442 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
444 echo "error: $title: invalid non-numeric in test" \
445 "selector: '$orig_selector'" >&2
450 # Short cut for "obvious" cases
451 test -z "$include" && test -z "$positive" && continue
452 test -n "$include" && test -n "$positive" && continue
456 if test $arg -le ${selector#-}
462 if test $arg -ge ${selector%-}
468 if test ${selector%%-*} -le $arg \
469 && test $arg -le ${selector#*-}
475 if test $arg -eq $selector
486 maybe_teardown_verbose () {
487 test -z "$verbose_only" && return
488 exec 4>/dev/null 3>/dev/null
493 maybe_setup_verbose () {
494 test -z "$verbose_only" && return
495 if match_pattern_list $test_count $verbose_only
498 # Emit a delimiting blank line when going from
499 # non-verbose to verbose. Within verbose mode the
500 # delimiter is printed by test_expect_*. The choice
501 # of the initial $last_verbose is such that before
502 # test 1, we do not print it.
503 test -z "$last_verbose" && echo >&3 ""
506 exec 4>/dev/null 3>/dev/null
509 last_verbose=$verbose
512 maybe_teardown_valgrind () {
513 test -z "$GIT_VALGRIND" && return
514 GIT_VALGRIND_ENABLED=
517 maybe_setup_valgrind () {
518 test -z "$GIT_VALGRIND" && return
519 if test -z "$valgrind_only"
521 GIT_VALGRIND_ENABLED=t
524 GIT_VALGRIND_ENABLED=
525 if match_pattern_list $test_count $valgrind_only
527 GIT_VALGRIND_ENABLED=t
531 # This is a separate function because some tests use
532 # "return" to end a test_expect_success block early
533 # (and we want to make sure we run any cleanup like
535 test_eval_inner_ () {
536 # Do not add anything extra (including LF) after '$*'
538 test \"$trace\" = t && set -x
543 # We run this block with stderr redirected to avoid extra cruft
544 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
545 # the shell from printing the "set +x" to turn it off (nor the saving
546 # of $? before that). But we can make sure that the output goes to
549 # The test itself is run with stderr put back to &4 (so either to
550 # /dev/null, or to the original stderr if --verbose was used).
552 test_eval_inner_ "$@" </dev/null >&3 2>&4
557 if test "$test_eval_ret_" != 0
559 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
563 return $test_eval_ret_
572 teardown_malloc_check
574 if test -z "$immediate" || test $eval_ret = 0 ||
575 test -n "$expecting_failure" && test "$test_cleanup" != ":"
578 test_eval_ "$test_cleanup"
579 teardown_malloc_check
581 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
589 test_count=$(($test_count+1))
596 maybe_teardown_valgrind
597 maybe_teardown_verbose
603 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
606 skipped_reason="GIT_SKIP_TESTS"
608 if test -z "$to_skip" && test -n "$test_prereq" &&
609 ! test_have_prereq "$test_prereq"
614 if test "$missing_prereq" != "$test_prereq"
616 of_prereq=" of $test_prereq"
618 skipped_reason="missing $missing_prereq${of_prereq}"
620 if test -z "$to_skip" && test -n "$run_list" &&
621 ! match_test_selector_list '--run' $test_count "$run_list"
624 skipped_reason="--run"
629 say_color skip >&3 "skipping test: $@"
630 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
639 # stub; perf-lib overrides it
640 test_at_end_hook_ () {
647 if test -z "$HARNESS_ACTIVE"
649 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
650 mkdir -p "$test_results_dir"
652 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
654 cat >>"$test_results_path" <<-EOF
656 success $test_success
664 if test "$test_fixed" != 0
666 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
668 if test "$test_broken" != 0
670 say_color warn "# still have $test_broken known breakage(s)"
672 if test "$test_broken" != 0 || test "$test_fixed" != 0
674 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
675 msg="remaining $test_remaining test(s)"
677 test_remaining=$test_count
678 msg="$test_count test(s)"
680 case "$test_failure" in
682 # Maybe print SKIP message
683 if test -n "$skip_all" && test $test_count -gt 0
685 error "Can't use skip_all after running some tests"
687 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
689 if test $test_external_has_tap -eq 0
691 if test $test_remaining -gt 0
693 say_color pass "# passed all $msg"
695 say "1..$test_count$skip_all"
698 test -d "$remove_trash" &&
699 cd "$(dirname "$remove_trash")" &&
700 rm -rf "$(basename "$remove_trash")"
707 if test $test_external_has_tap -eq 0
709 say_color error "# failed $test_failure among $msg"
718 if test -n "$valgrind"
722 test "$1" = "$(readlink "$2")" || {
730 while test -d "$2".lock
732 say "Waiting for lock on $2."
739 make_valgrind_symlink () {
740 # handle only executables, unless they are shell libraries that
741 # need to be in the exec-path.
743 test "# " = "$(head -c 2 <"$1")" ||
746 base=$(basename "$1")
747 symlink_target=$GIT_BUILD_DIR/$base
748 # do not override scripts
749 if test -x "$symlink_target" &&
750 test ! -d "$symlink_target" &&
751 test "#!" != "$(head -c 2 < "$symlink_target")"
753 symlink_target=../valgrind.sh
757 symlink_target=../unprocessed-script
759 # create the link, or replace it if it is out of date
760 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
763 # override all git executables in TEST_DIRECTORY/..
764 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
765 mkdir -p "$GIT_VALGRIND"/bin
766 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
768 make_valgrind_symlink $file
770 # special-case the mergetools loadables
771 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
776 ls "$path"/git-* 2> /dev/null |
779 make_valgrind_symlink "$file"
783 PATH=$GIT_VALGRIND/bin:$PATH
784 GIT_EXEC_PATH=$GIT_VALGRIND/bin
786 GIT_VALGRIND_MODE="$valgrind"
787 export GIT_VALGRIND_MODE
788 GIT_VALGRIND_ENABLED=t
789 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
790 export GIT_VALGRIND_ENABLED
791 elif test -n "$GIT_TEST_INSTALLED"
793 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
794 error "Cannot run git from $GIT_TEST_INSTALLED."
795 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
796 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
797 else # normal case, use ../bin-wrappers only unless $with_dashes:
798 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
799 if ! test -x "$git_bin_dir/git"
801 if test -z "$with_dashes"
803 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
807 PATH="$git_bin_dir:$PATH"
808 GIT_EXEC_PATH=$GIT_BUILD_DIR
809 if test -n "$with_dashes"
811 PATH="$GIT_BUILD_DIR:$PATH"
814 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
815 GIT_CONFIG_NOSYSTEM=1
817 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
819 if test -z "$GIT_TEST_CMP"
821 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
823 GIT_TEST_CMP="$DIFF -c"
825 GIT_TEST_CMP="$DIFF -u"
829 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
831 test -d "$GIT_BUILD_DIR"/templates/blt || {
832 error "You haven't built things yet, have you?"
835 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
837 echo >&2 'You need to build test-chmtime:'
838 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
843 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
844 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
845 case "$TRASH_DIRECTORY" in
846 /*) ;; # absolute path is good
847 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
849 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
850 rm -fr "$TRASH_DIRECTORY" || {
852 echo >&5 "FATAL: Cannot prepare test area"
856 HOME="$TRASH_DIRECTORY"
857 GNUPGHOME="$HOME/gnupg-home-not-used"
858 export HOME GNUPGHOME
860 if test -z "$TEST_NO_CREATE_REPO"
862 test_create_repo "$TRASH_DIRECTORY"
864 mkdir -p "$TRASH_DIRECTORY"
866 # Use -P to resolve symlinks in our working directory so that the cwd
867 # in subprocesses like git equals our $PWD (for pathname comparisons).
868 cd -P "$TRASH_DIRECTORY" || exit 1
871 this_test=${this_test%%-*}
872 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
874 say_color info >&3 "skipping test $this_test altogether"
875 skip_all="skip all tests in $this_test"
879 # Provide an implementation of the 'yes' utility
894 # Fix some commands on Windows
897 # Windows has its own (incompatible) sort and find
907 # git sees Windows-style pwd
911 # no POSIX permissions
912 # backslashes in pathspec are converted to '/'
913 # exec does not inherit the PID
914 test_set_prereq MINGW
915 test_set_prereq NATIVE_CRLF
916 test_set_prereq SED_STRIPS_CR
917 test_set_prereq GREP_STRIPS_CR
918 GIT_TEST_CMP=mingw_test_cmp
921 test_set_prereq POSIXPERM
922 test_set_prereq EXECKEEPSPID
923 test_set_prereq CYGWIN
924 test_set_prereq SED_STRIPS_CR
925 test_set_prereq GREP_STRIPS_CR
928 test_set_prereq POSIXPERM
929 test_set_prereq BSLASHPSPEC
930 test_set_prereq EXECKEEPSPID
934 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
935 test -z "$NO_PERL" && test_set_prereq PERL
936 test -z "$NO_PYTHON" && test_set_prereq PYTHON
937 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
938 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
940 # Can we rely on git's output in the C locale?
941 if test -n "$GETTEXT_POISON"
943 GIT_GETTEXT_POISON=YesPlease
944 export GIT_GETTEXT_POISON
945 test_set_prereq GETTEXT_POISON
947 test_set_prereq C_LOCALE_OUTPUT
950 # Use this instead of test_cmp to compare files that contain expected and
951 # actual output from git commands that can be translated. When running
952 # under GETTEXT_POISON this pretends that the command produced expected
955 test -n "$GETTEXT_POISON" || test_cmp "$@"
958 # Use this instead of "grep expected-string actual" to see if the
959 # output from a git command that can be translated either contains an
960 # expected string, or does not contain an unwanted one. When running
961 # under GETTEXT_POISON this pretends that the command produced expected
964 if test -n "$GETTEXT_POISON"
967 elif test "x!" = "x$1"
976 test_lazy_prereq PIPE '
977 # test whether the filesystem supports FIFOs
983 rm -f testfifo && mkfifo testfifo
988 test_lazy_prereq SYMLINKS '
989 # test whether the filesystem supports symbolic links
990 ln -s x y && test -h y
993 test_lazy_prereq FILEMODE '
994 test "$(git config --bool core.filemode)" = true
997 test_lazy_prereq CASE_INSENSITIVE_FS '
998 echo good >CamelCase &&
999 echo bad >camelcase &&
1000 test "$(cat CamelCase)" != good
1003 test_lazy_prereq UTF8_NFD_TO_NFC '
1004 # check whether FS converts nfd unicode to nfc
1005 auml=$(printf "\303\244")
1006 aumlcdiar=$(printf "\141\314\210")
1016 test_lazy_prereq AUTOIDENT '
1017 sane_unset GIT_AUTHOR_NAME &&
1018 sane_unset GIT_AUTHOR_EMAIL &&
1019 git var GIT_AUTHOR_IDENT
1022 test_lazy_prereq EXPENSIVE '
1023 test -n "$GIT_TEST_LONG"
1026 test_lazy_prereq USR_BIN_TIME '
1027 test -x /usr/bin/time
1030 # When the tests are run as root, permission tests will report that
1031 # things are writable when they shouldn't be.
1032 test -w / || test_set_prereq SANITY
1034 GIT_UNZIP=${GIT_UNZIP:-unzip}
1035 test_lazy_prereq UNZIP '